// These are the answers to the 442 review questions
// It is a companion file to review442.html
//
// Answers are popped up as JavaScript alert boxes so they can be
// seen on the same page as the question (you can drag the alert
// box out of the way to re-read the question as you look at the
// answer if you need to).
//
// I'm sure there's a "better" way to do this, but Javascript is not
// my bag; the alert boxes seem to do mostly what I want.  They're not
// ideal because of the inability to control fonts, emphasis, etc. 
// Other solutions depend on the server, which is harder to count on
// in class
//
// A scoring function would be easy to implement but is presently
// not included - intentionally, to make sure this stays fun!
//
// Copyright (c) 2000-2001 Mats Wichmann.  Please see review442.html for
// rights and restrictions on use and distribution of this software
//
// Version of 27 Aug 2001

var explain01 = "\n" +
"UNIX login names are limited to 8 characters, must be unique on the\n" +
"system, and are case-sensitive";
function ans01(answer) {
    if(answer == 'a')
	alert("That's right!" + explain01);
    else
	alert("The answer is a. " + explain01);
    location.replace("#q01");
}


var explain02 = "\n";
function ans02(answer) {
    if(answer == 'c')
	alert("That's right!");
    else
	alert("The correct answer is c.");
    location.replace("#q02");
}


var explain03 = "\n" +
"Note: Sun now prefers CDE.  The older OpenWindows is still\n" +
"supported but now generates a warning.  Sun has also announced\n" +
"participation in the Gnone project and may supply Gnome in the\n" +
"future (as of mid-2001, it was available as a free download\n" +
"from Sun's website). KDE and Gnome are both very popular on Linux.\n"
function ans03(answer) {
    if(answer == 'b')
	alert("That's right!" + explain03);
    else
	alert("The correct answer is b." + explain03);
    location.replace("#q03");
}


var explain04 = "\n" +
"Note: on GNU/Linux systems, there may also be information available \n" +
"via a command called info";
function ans04(answer) {
    if(answer == 'c')
	alert("Right!" + explain04);
    else
	alert("The answer is c - the man command." + explain04);
    location.replace("#q04");
}


var explain05 = "\n" +
"Remember, all characters except '/' are legal in filenames - but some\n" +
"filenames are bad ideas because they're hard to work with.";
function ans05(answer) {
    if(answer == 'e')
	alert("That's right!" + explain05);
    else
	alert("The answer is e" + explain05);
    location.replace("#q05");
}


var explain06 = "\n" +
"Remember: 'l' for a long listing, 'i' to print the index numbers, \n" +
"and writings as the filename argument ('d' won't show contents!)";
function ans06(answer) {
    if(answer == 'b')
	alert("Right!" + explain06);
    else
	alert("The answer is b." + explain06);
    location.replace("#q06");
}


var explain07 = "\n";
function ans07(answer) {
    if(answer == 'b')
	alert("You are right!");
    else
	alert("The correct answer is b.");
    location.replace("#q07");
}


var explain08 = "\n";
function ans08(answer) {
    if(answer == 'd')
	alert("That's right - you've got links figured out!");
    else
	alert("The answer is d.  Try drawing a picture to think about how this works.");
    location.replace("#q08");
}


var explain09 = "\n" +
"Remember: ln existing-filename new-filename (ln -s makes a symbolic link)";
function ans09(answer) {
    if(answer == 'b')
	alert("That's right!" + explain09);
    else
	alert("The answer is b." + explain09);
    location.replace("#q09");
}


var explain10 = "\n" +
"The answer is d.  '4' is read, '2' is write and '1' is execute...\n" +
"since it's a regular file there can't be a 'd' in the first column";
function ans10(answer) {
    if(answer == 'd')
	alert("That's right! (123 is not a useful permission - but legal!)");
    else
	alert("The answer is d." + explain10);
    location.replace("#q10");
}


var explain11 = "\n" +
"... because you don't have that information...you need to know the\n" +
"directory permissions to to know if you can remove the file";
function ans11(answer) {
    if(answer == 'c')
	alert("That's right!" + explain11);
    else
	alert("They are all true except c." + explain11);
    location.replace("#q11");
}


var explain12 = "\n";
function ans12(answer) {
    if(answer == 'c')
	alert("That's right!");
    else
	alert("The answer is c.");
    location.replace("#q12");
}


var explain13 = "\n";
function ans13(answer) {
    if(answer == 'd')
	alert("That's right!");
    else
	alert("The answer is d.");
    location.replace("#q13");
}


var explain14 = "\n";
function ans14(answer) {
    if(answer == 'c')
	alert("That's right!");
    else
	alert("The answer is c.");
    location.replace("#q14");
}


var explain15 = "\n";
function ans15(answer) {
    if(answer == 'd')
	alert("That's right!");
    else
	alert("The correct answer is d.");
    location.replace("#q15");
}


var explain16 = "\n";
function ans16(answer) {
    if(answer == 'b')
	alert("That's right!");
    else
	alert("The correct answer is b.");
    location.replace("#q16");
}


var explain17 = "\n" +
"The trick here is to specify the filename in a way such that the first\n"+
"character is not a dash.  One easy way to do that is to refer to the\n"+
"filename relative to the current directory by using ./ \n"+
"To see what happens when you try to solve this with wildcards, use echo\n"+
"to show the command line the way it would be run.";
function ans17(answer) {
    if(answer == 'c')
	alert("That's right" + explain17);
    else
	alert("The answer is c" + explain17);
    location.replace("#q17");
}


var explain18 = "\n\n" +
"To match the beginning dot, you need a dot. You don't want to show \n"+
". and .. though, so .* and .?* aren't quite good enough. There are really\n"+
"three 'correct' answers to this one...  .??* is good enough for most\n"+
"cases although it does miss files with a dot followed by a single\n"+
"character. Answer d. specifics a dot followed by the ranges control-a (^A)\n"+
"to dash and 0 to delete (^?) --if you know the ascii character \n" +
"set well (try 'man ascii' to see)-- and works for all shells, but is hard\n"+
"to remember, and to type. Answer e. works for the Korn shell\n " +
"because the ! means 'not' inside brackets in the Korn shell.\n" +
"We didn't talk about answer e. in the course, and it doesn't work\n"+
"for every shell.";
function ans18(answer) {
    if(answer == 'c' || answer == 'd' || answer == 'e')
	alert("That's one right answer - read on" + explain18);
    else
	alert("That won't quite do it, read on:" + explain18);
    location.replace("#q18");
}


var explain19 = "\n" +
"The shell's job control commands are: & to start a job in the background,\n" +
"^Z to suspend a job in the foreground, fg to bring a job to the foreground,\n"+
"bg to restart a suspended job in the background, and jobs to show status.";
function ans19(answer) {
    if(answer == 'a')
	alert("That's right!" + explain19);
    else
	alert("The answer is a." + explain19);
    location.replace("#q19");
}


var explain20 = "\n";
function ans20(answer) {
    if(answer == 'b')
	alert("That's right" + explain20);
    else
	alert("The answer is b" + explain20);
    location.replace("#q20");
}


var explain21 = "\n";
function ans21(answer) {
    if(answer == 'd')
	alert("That's right" + explain21);
    else
	alert("The answer is d" + explain21);
    location.replace("#q21");
}


var explain22 = "\n" +
"To make this work, you need to remember that you need three pieces to a\n" +
"find command: where-to-look, what-to-look-for, and what-to-do.\n" +
"These are:  your CWD (.); files ending in .o which you specify with -name\n"+
"(and put the wildcards in quotes so the shell doesn't expand it first);\n"+
"and -exec the rm command.\n";
function ans22(answer) {
    if(answer == 'c')
	alert("That's right" + explain22);
    else
	alert("The answer is c" + explain22);
    location.replace("#q22");
}


var explain23 = "\n" +
"* selects all of the files (not *.* which selects all files which have\n"+
"a period in them!); to specify a directory in the parent directory use\n"+
"a relative path and navigate up one level with ..   As long as the last\n"+
"argument on a cp command is a directory, all the other files are copied\n"+
"into that directory.";
function ans23(answer) {
    if(answer == 'b')
	alert("That's right" + explain23);
    else
	alert("The answer is b" + explain23);
    location.replace("#q23");
}


var explain24 = "\n" +
"sort by itself doesn't change the file's data. You need to save the result\n"+
"of the sort command somehow.  However, if you redirect to the same file,\n"+
"you get a result you might not exepct: the shell first sets up the redirect\n"+
"before running the command, and as a side effect, clears the contents of\n"+
"the file to be redirected to if it already exists (unless the shell option\n"+
"noclobber is set - shell options are coming up in a later chapter!).\n" +
"Thus, the file is cleared before sort opens it up, so sort will be sorting\n"+
"an empty file....oops!  Of the choices offered, the one that works is to\n"+
"save to a temporary file, then rename it. Sort also offers the -o option\n"+
"handle this - check the manual page";
function ans24(answer) {
    if(answer == 'd')
	alert("That's right" + explain24);
    else
	alert("The answer is d" + explain24);
    location.replace("#q24");
}


var explain25 = "\n";
function ans25(answer) {
    if(answer == 'a')
	alert("That's right" + explain25);
    else
	alert("The answer is a" + explain25);
    location.replace("#q25");
}


var explain26 = "\n"+
"Think about how to structure this problem.  You want entries that refer\n"+
"to tips, which says use grep.  Grep's first argument (other than options)\n"+
"is the pattern to look for. You want a number - a count - which says\n"+
"use wc (wc -l to get just lines).  What do you want to count? Lines which\n"+
"contain tips, so you need the grep first to select those lines, then the\n"+
"wc to count that result. Thus the grep is left of the pipeline and wc right";
function ans26(answer) {
    if(answer == 'd')
	alert("That's right" + explain26);
    else
	alert("The answer is d" + explain26);
    location.replace("#q26");
}


var explain27 = "\n";
function ans27(answer) {
    if(answer == 'b')
	alert("That's right" + explain27);
    else
	alert("The answer is b" + explain27);
    location.replace("#q27");
}


var explain28 = "\n" +
"Notice that because the second sed has been given a filename, it ignores\n" +
"standard input - in other words, the result of the first sed is ignored.\n" +
"The second sed is not specifying the global option in the substitute\n" +
"command, so only the first instance on each line is changed.  And sed does\n" +
"not operate 'in place' - the data is copied to the output stream instead";
function ans28(answer) {
    if(answer == 'e')
	alert("That's right" + explain28);
    else
	alert("The answer is e" + explain28);
    location.replace("#q28");
}


var explain29 = "\n" +
"The awk command needs to specify the | symbol as the separator. Since that\n"+
"character is special to the shell (creates a pipeline) it must be escaped\n" +
"so that it is passed undisturbed to awk, otherwise the shell tries to\n"+
"construct a pipline from awk to the print statement - which will be an error";
function ans29(answer) {
    if(answer == 'd')
	alert("That's right" + explain29);
    else
	alert("The answer is d" + explain29);
    location.replace("#q29");
}


var explain30 = "\n" +
"Remember that the shell rewrites the command line as it processes it.\n" +
"Since it's not always clear that you're getting what you think you're\n" +
"getting, echo makes a useful debugging tool: it just writes back its'\n" +
"arguments, but first all the shell expandion (rewriting) has a chance to\n" +
"happen, so echo will show you the effect of expensions on a command line\n" +
"without actually running it.";
function ans30(answer) {
    if(answer == 'd')
	alert("That's right" + explain30);
    else
	alert("The answer is d" + explain30);
    location.replace("#q30");
}


var explain31 = "\n" +
"Answer d. performs command substitution - it runs the command in backquotes\n"+
"first, then subsitutes the result in in place of that command sequence.\n" +
"Answer e. shows an alternative form of the same thing, although not for all\n"+
"shells - works fine for the Korn shell";
function ans31(answer) {
    if(answer == 'd' || answer == 'e')
	alert("That's right!" + explain31);
    else
	alert("Both d and e are correct" + explain31);
    location.replace("#q31");
}


var explain32 = "\n";
function ans32(answer) {
    if(answer == 'a')
	alert("That's right" + explain32);
    else
	alert("The answer is a" + explain32);
    location.replace("#q32");
}


var explain33 = "\n";
function ans33(answer) {
    if(answer == 'c')
	alert("That's right!");
    else
	alert("The correct answer is c.");
    location.replace("#q33");
}


var explain34 = "\n" +
"The problem with a. is that it's not quoted at all, so the apostrophe\n" +
"is treaded as a beginning quote - which is not matched by a closing\n" +
"quote. Trying single quotes, as in b., is not the answer. In this case,\n" +
"the apostrophe becomes the close to the beginning quote, and then the\n" +
"# marks the beginning of a comment, so the rest of the line is just\n" +
"ignored!  Trying double quotes as in c. is still not the whole answer.\n" +
"Here most of the meanings are turned off, but variable substitution\n" +
"still works, so $$ is treated as a variable substitution - $$ means\n" +
"the process ID number of this shell!  Answer d. attempts to fix that\n" +
"problem by surrounding the $$ in single quotes, but since single\n" +
"quotes have no special meaning inside double quotes, that doesn't\n" +
"work either.  The final effort uses a backslash to escape the\n" +
"meaning of $, because backslash does retain its' special meaning\n" +
"inside double quotes.  Genius point if you got it!!!";
function ans34(answer) {
    if(answer == 'e')
	alert("That's right!" + explain34);
    else
	alert("The correct answer is e." + explain34);
    location.replace("#q34");
}


var explain35 = "\n";
function ans35(answer) {
    if(answer == 'e')
	alert("That's right" + explain35);
    else
	alert("The answer is e" + explain35);
    location.replace("#q35");
}


var explain36 = "\n";
function ans36(answer) {
    if(answer == 'c')
	alert("That's right" + explain36);
    else
	alert("The answer is c" + explain36);
    location.replace("#q36");
}


var explain37 = "\n\n" +
"To match one-or-more of a pattern at the beginning of a line, you need\n" +
"the anchor character (^), then you need the pattern (#) once to make\n" +
"sure you get the 'one' part, then the pattern again followed by the\n" +
"modifier (#*) to get the 'or more' part.";
function ans37(answer) {
    if(answer == 'e')
	alert("That's right!" + explain37);
    else
	alert("The answer is e" + explain37);
    location.replace("#q37");
}


var explain38 = "\n";
function ans38(answer) {
    if(answer == 'b')
	alert("That's right" + explain38);
    else
	alert("The answer is b" + explain38);
    location.replace("#q38");
}


var explain39 = "\n" +
"The point here is that a shell script is commands to the shell saved in\n" +
"an ordinary text file, and marked as executable (text files by default\n" +
"are created without the execute bits set). There are no special steps\n" +
"that need to be taken - the original UNIX developers wanted to eliminate\n" +
"the barriers between 'programmers' and 'ordinary users' by giving everyone\n"+
"all the power they need to automate their tasks.";
function ans39(answer) {
    if(answer == 'd')
	alert("That's right" + explain39);
    else
	alert("The answer is d" + explain39);
    location.replace("#q39");
}


var explain40 = "\n" +
"When a script is called with arguments, the first nine are available as\n" +
"$1 through $9. The program (script name) itself is $0 so you count on\n" +
"the command line starting from 0.  The arguments are also available through\n"+
"$*, but not directly - you have to use a loop to find them";
function ans40(answer) {
    if(answer == 'a')
	alert("That's right" + explain40);
    else
	alert("The answer is a" + explain40);
    location.replace("#q40");
}


var explain41 = "\n" +
"mv *.foo *.bar doesn't work because the shell expands filename wildcards\n"+
"to match existing filenames - you can't use wildcards to create filenames\n"+
"that don't exist. Using echo will show how the command line has been\n"+
"rewritten - and it won't do the right thing. A shell loop is a good way to\n"+
"solve this problem. With the tools we've covered in class, it's a little\n"+
"bulky, but we can build up a solution using echo to print the old filename\n"+
"and pipe it to sed to change the suffix .foo to .bar. We do the whole \n"+
"thing in command substitution:\n\n"+
"for file in *.foo\n"+
"do\n"+
"    mv $file $(echo $file | sed 's/\\.foo$/.bar/')   # change .foo to .bar\n"+
"done\n\n" +
"The Korn shell has a built-in way to deal with suffixes (not covered in\n"+
"class!) which could do this a little easier:\n\n"+
"for f in *.foo\n"+
"do\n"+
"    mv $file ${file%foo}bar\n"+
"done\n\n"+
"If this all makes sense you've just graduated to power user!!!";
function show41() {
    alert(explain41);
    location.replace("#q41");
}


// XXX
var explain42 = "\n";
function ans42(answer) {
    if(answer == 'a')
	alert("That's right" + explain42);
    else
	alert("The answer is a" + explain42);
    location.replace("#q42");
}


// XXX
var explain43 = "\n";
function ans43(answer) {
    if(answer == 'c')
	alert("That's right" + explain43);
    else
	alert("The answer is a" + explain43);
    location.replace("#q43");
}


// XXX
var explain44 = "\n";
function ans44(answer) {
    if(answer == 'a')
	alert("That's right" + explain44);
    else
	alert("The answer is a" + explain44);
    location.replace("#q44");
}


var explain45 = "\n";
function ans45(answer) {
    if(answer == 'a')
	alert("That's right!");
    else
	alert("The correct answer is a.");
    location.replace("#q45");
}


var explain46 = "\n";
function ans46(answer) {
    if(answer == 'd')
	alert("That's right!");
    else
	alert("The correct answer is d.");
    location.replace("#q46");
}


var explain47 = "\n";
function ans47(answer) {
    if(answer == 'a')
	alert("That's right!");
    else
	alert("No, it's true.  This is something to watch out for!");
    location.replace("#q47");
}


var explain48 = "\n";
function ans48(answer) {
    if(answer == 'b')
	alert("That's right!");
    else
	alert("The correct answer is b.");
    location.replace("#q48");
}


var explain49 = "\n";
function ans49(answer) {
    if(answer == 'a')
	alert("That's right!");
    else
	alert("The correct answer is a.");
    location.replace("#q49");
}


var explain50 = "\n";
function ans50(answer) {
    if(answer == 'a')
	alert("That's right!");
    else
	alert("The correct answer is a.");
    location.replace("#q50");
}


var explain51 = "\n";
function ans51(answer) {
    if(answer == 'a')
	alert("That's right" + explain51);
    else
	alert("The answer is a" + explain51);
    location.replace("#q51");
}


var explain52 = "\n";
function ans52(answer) {
    if(answer == 'c')
	alert("That's right" + explain52);
    else
	alert("The answer is c" + explain52);
    location.replace("#q52");
}


var explain53 = "\n";
function ans53(answer) {
    if(answer == 'a')
	alert("That's right" + explain53);
    else
	alert("The answer is a" + explain53);
    location.replace("#q53");
}


var explain54 = "\n\n" +
"The rcp command works just like the rcp command, except that the source,\n"+
"destination, or both can take a preceding hostname: to specify a remote\n"+
"machine.  For a remote machine, if a relative pathanme is used, it will\n"+
"be relative to your home directory on that machine.";
function ans54(answer) {
    if(answer == 'b')
	alert("That's right" + explain54);
    else
	alert("The answer is b" + explain54);
    location.replace("#q54");
}


var explain55 = "\n\n" +
"In this situation, mailx needs to get the message body from the input\n"+
"(either through a pipe or input redirection), have the subject specified\n"+
"with the -s flag, and the list of recipients on the command line. Since\n"+
"neither subject or recipients are fully known, we generate them using\n"+
"command substitution.\n";
function ans55(answer) {
    if(answer == 'b')
	alert("That's right" + explain55);
    else
	alert("The answer is b" + explain55);
    location.replace("#q55");
}


var explain56 = "\n\n" +
"Recall that windows are positioned using an x,y coordinate system where\n"+
"the reference point is the upper left corner and the x (horiz.) position\n"+
"is listed first, so a positive x-offset is from the left of the screeen\n"+
"and a negative x-offset is from the right of the screen\n";
function ans56(answer) {
    if(answer == 'c')
	alert("That's right!" + explain56);
    else
	alert("The answer is c" + explain56);
    location.replace("#q56");
}


var explain57 = "\n\n" +
"X Window System commands take a -display option to specify where to send\n"+
"the display.  The specifier is of the form hostname:displaynumber with\n"+
"an optional .screennumber suffix\n";
function ans57(answer) {
    if(answer == 'd')
	alert("That's right" + explain57);
    else
	alert("The answer is d" + explain57);
    location.replace("#q57");
}
